<script setup>
import { useNotificationStore } from "@/stores/useNotificationStore";
import { useWebsocketStore } from "@/stores/useWebsocketStore";
////////////////////////////////
// IMPORT
////////////////////////////////
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";
import { onMounted } from "vue";

////////////////////////////////
// VARIABLES
////////////////////////////////

const workspaceStore = useWorkspaceStore();
const notificationStore = useNotificationStore();
const websocketStore = useWebsocketStore();

const False = false;
const filterNotifications = ref("read_unread");

const menuOpen = ref(false);
const actionMenu = ref(false);
const reloadKey = ref(0);

const filterMenu = ref(false);
const filters = [
  { id: "read_unread", icon: "mdi-inbox-outline", filter: "read_unread" },
  { id: "unread", icon: "mdi-checkbox-blank-badge-outline", filter: "unread" },
  { id: "archived", icon: "mdi-archive-outline", filter: "archived" },
];

////////////////////////////////
// LIFECYCLE
////////////////////////////////

onMounted(async () => {
  if (workspaceStore.workspaceMap.size === 0) {
    await workspaceStore.fetchWorkspaces();
  }
  await notificationStore.fetchNotifications("archived=False");
});

////////////////////////////////
// FUNCTIONS
////////////////////////////////

async function load({ done }) {
  // Perform API call
  if (
    notificationStore.totalPages === -1
    || (notificationStore.totalPages !== -1
      && notificationStore.currentPage < notificationStore.totalPages)
  ) {
    switch (filterNotifications.value) {
      case "read_unread":
        await notificationStore.fetchNotifications("archived=False");
        break;
      case "archived":
        await notificationStore.fetchNotifications("archived=True");
        break;
      case "unread":
        await notificationStore.fetchNotifications("archived=False&unread=True");
        break;
    }
    done("ok");
  } else {
    done("empty");
  }
}

const countUnreadNotification = computed(() => {
  const newWorkspaceId = workspaceStore.currentWid;
  return Array.from(notificationStore.notifications.values()).filter(
    notification => notification.unread && notification.description === newWorkspaceId,
  ).length;
});

////////////////////////////////
// WATCH
////////////////////////////////

watch(
  () => websocketStore.message,
  async (newValue) => {
    if (newValue !== null) {
      filterNotifications.value = "read_unread";
      notificationStore.clear();
      await notificationStore.fetchNotifications("archived=False");
    }
  },
);

watch(
  () => workspaceStore.currentWid,
  async (newWorkspaceId, oldWorkspaceId) => {
    if (newWorkspaceId !== oldWorkspaceId) {
      notificationStore.clear();
      await notificationStore.fetchNotifications("archived=False");
    }
  },
);

watch(
  () => workspaceStore.workspaceMap,
  async () => {
    notificationStore.fetchNotifications();
    await load({ done: () => {} });
  },
);
</script>

<template>
  <div>
    <v-menu
      v-model="menuOpen"
      location="end"
      :close-on-content-click="False"
      width="500px"
    >
      <template v-slot:activator="{ props }">
        <v-list-item
          density="compact"
          v-bind="props"
          class="ma-0 pa-0"
        >
          <v-icon class="me-2">
            mdi-inbox-outline
          </v-icon>{{ $t("inbox") }}
          <template v-slot:append>
            <v-badge
              v-if="countUnreadNotification !== 0"
              color="error"
              :content="countUnreadNotification"
              inline
            />
          </template>
        </v-list-item>
      </template>
      <div class="modal-background elevation-10">
        <v-toolbar density="compact" color="white">
          <template v-slot:prepend>
            <p class="font-weight-bold text-overline mx-2">
              {{ $t("inbox") }}
            </p>
            <v-menu v-model="filterMenu" :close-on-content-click="false">
              <template v-slot:activator="{ props }">
                <v-btn
                  icon="mdi-filter-variant"
                  :color="filterNotifications === 'read_unread' ? 'gray' : 'blue'"
                  v-bind="props"
                />
              </template>
              <v-list>
                <p class="ms-2 text-grey-darken-1">
                  {{ $t("filters") }}
                </p>
                <v-list-item
                  v-for="(item, index) in filters"
                  :key="index"
                  :value="index"
                  @click="
                    filterNotifications = item.filter;
                    filterMenu = !filterMenu;
                    notificationStore.clear();
                    reloadKey++;
                  "
                >
                  <template v-slot:prepend>
                    <v-icon :icon="item.icon" />
                  </template>
                  <v-list-item-title> {{ $t(item.id) }}</v-list-item-title>
                  <template v-slot:append>
                    <v-icon
                      icon="mdi-check"
                      :color="filterNotifications === item.filter ? 'black' : 'white'"
                    />
                  </template>
                </v-list-item>
              </v-list>
            </v-menu>
          </template>
          <v-menu v-model="actionMenu" :close-on-content-click="false">
            <template v-slot:activator="{ props }">
              <v-btn
                icon="mdi-dots-horizontal"
                size="25"
                variant="text"
                color="gray"
                v-bind="props"
              />
            </template>
            <v-list>
              <!-- Read & unread and Unread btns -->
              <v-list-item
                v-if="['read_unread', 'unread'].includes(filterNotifications)"
                @click="notificationStore.markAsReadAll"
              >
                <template v-slot:prepend>
                  <v-icon icon="mdi-email-open-outline" />
                </template>
                <v-list-item-title>{{ $t("marke_all_as_read") }}</v-list-item-title>
              </v-list-item>
              <v-list-item
                v-if="['read_unread', 'unread'].includes(filterNotifications)"
                @click="notificationStore.archivedAll"
              >
                <template v-slot:prepend>
                  <v-icon icon="mdi-archive-outline" />
                </template>
                <v-list-item-title> {{ $t("all_archived") }}</v-list-item-title>
              </v-list-item>

              <!-- Archived Btns -->

              <v-list-item
                v-if="filterNotifications === 'archived'"
                @click="notificationStore.restoreArchivedAll"
              >
                <template v-slot:prepend>
                  <v-icon icon="mdi-restore" />
                </template>
                <v-list-item-title>{{ $t("restore_all_notifs") }}</v-list-item-title>
              </v-list-item>
              <v-list-item
                v-if="filterNotifications === 'archived'"
                @click="notificationStore.clearNotifications"
              >
                <template v-slot:prepend>
                  <v-icon icon="mdi-trash-can-outline" />
                </template>
                <v-list-item-title> {{ $t("clear_notifs") }}</v-list-item-title>
              </v-list-item>
            </v-list>
          </v-menu>
        </v-toolbar>

        <div style="height: 70vh">
          <div class="overflow-y-auto item-list">
            <v-infinite-scroll
              :key="reloadKey"
              :items="notificationStore.notifications"
              :onLoad="load"
            >
              <template v-if="notificationStore.notifications.size > 0">
                <template v-for="[key, notification] of notificationStore.notifications" :key="key">
                  <div class="d-flex flex-row">
                    <v-badge
                      v-if="notification.unread"
                      color="error"
                      dot
                      inline
                      class="mt-2"
                    />
                    <v-badge
                      v-else
                      color="white"
                      dot
                      inline
                      class="mt-2"
                      style="opacity: 0"
                    />
                    <NotificationsItem
                      :notification="notification"
                      :filter-notifications="filterNotifications"
                      @menu-open="menuOpen = false"
                    />
                  </div>
                </template>
              </template>
              <template v-else>
                <div class="text-center mt-10">
                  <v-icon size="100" color="grey">
                    mdi-inbox-outline
                  </v-icon>

                  <p
                    v-if="['read_unread', 'unread'].includes(filterNotifications)"
                    color="text-grey"
                  >
                    <b> {{ $t("your_are_uptodate_title") }}</b><br>
                    {{ $t("your_are_uptodate_text") }}
                  </p>

                  <p v-if="filterNotifications === 'archived'" color="text-grey">
                    <b>{{ $t("no_notif_archived_title") }}</b><br>
                    {{ $t("no_notif_archived_text") }}
                  </p>
                </div>
              </template>
            </v-infinite-scroll>
          </div>
        </div>
      </div>
    </v-menu>
  </div>
</template>

<style>
.modal-background {
  background-color: rgb(var(--v-theme-background));
  border-radius: 5px;
}

.item-list {
  height: 70vh;
}

.small-text-btn .v-btn__content {
  font-size: 10px;
}
</style>
